Subject: Re: connecting existing local git repository to svn

From: Ittay Dror <[email-masked]>
Date: Wed, 28 Jan 2009 07:26:27 +0200

Michael J Gruber wrote:
> Ittay Dror venit, vidit, dixit 01/27/09 13:48:
>   
>> Sverre Rabbelier wrote:
>>
>>     
>>> On Tue, Jan 27, 2009 at 11:41, Ittay Dror <[email-masked]> wrote:
>>>   
>>>       
>>>> git: ----v1----v2----v3--v4---v5
>>>> svn:                     \---v4--v5
>>>>
>>>> so the svn history starts from v3, but the git history remains unchanged.
>>>>     
>>>>         
>>> Create the new branch from v3 then, and use git svn to pull it in.
>>> Then you can do 'git rebase that-svn-branch' on your git branch to put
>>> all commits (not as one big commit) on top of that branch point. Now
>>> you 'git checkout' that-svn-branch and do 'git reset --hard
>>> the-git-branch', which should now consist of
>>> v1--v2--v3--v4(git)--v5(git), etc. If you do 'git svn dcommit' from
>>> the that-svn-branch now it should dcommit to svn each of your git
>>>   
>>>       
>> sorry, my ascii art was confusing:
>>
>> git: ----v1----v2----v3--v4---v5
>> svn: v1-4---v5
>>
>> v1-4 is v1 to v4 squashed together. (e.g., if i added a file in v2 and 
>> removed in v3 it will not appear in svn history)
>>     
>
> Well, for git and svn "revisions" are really "versions" of the complete
> tree, not changesets. Have messed around with hg lately? ;)
>
> On the other hand, a commit that introduces a new version is the
> difference with respect to the previous "version".
>
>   
here's a new one:

initial
git: --- c1 --- c2 --- c3 --- c4

create svn:
git: --- c1 --- c2 --- c3 --- c4
svn --- c1|c2|c3|c4

where c1|c2|c3|c4 is the squashing of all commits into one. it is the 
first revision in the svn repository
c1|c2|c3|c4 === r1

do some work, commit, dcommit:
git: --- c1 --- c2 --- c3 --- c4 --- c5
svn --- c1|c2|c3|c4 --- r2

where 'r2' is revision 2 of the svn repository and contains the same 
changes as c5. that is diff(r2, r1) is the same as diff(c5, c4)

so the svn history starts from how the working tree looks like when it 
is created and progresses from there. the git history is unaltered. i 
want to keep on working on 'master' in git (and 'git log' should show 
all commits as before).

> Ususally it's clear what is meant, but you seem to mix both notions.
>
> So, if v? denotes a version, then v4 is the result of all commits
> leading up to v4. It *is* v4. "squashing" applies only to commits
> ("changes").
>
> In any case, Sverre's as well as my suggestions should do what you want.
> Why not try it out if you doubt it?
>   
well, sverre's suggestion says it will dcommit each git commit 
individually and i think your suggestion means i discard my git history 
in the branch i'm working on.

thank you,
ittay
> Cheers,
> Michael